<?php
/**
 * Plugin Name: Taro Can Fetch Authorized Feed
 * Plugin URI: https://tarosky.co.jp
 * Description: This plugin serve to get authorized feed URL.
 * Author: Tarosky INC.
 * Version: 0.1.0
 * Author URI: https://tarosky.co.jp
 * License: GPL3 or later
 * License URI: https://www.gnu.org/licenses/gpl-3.0.html
 * Text Domain: taro-can-fetch-authorized-feed
 * Domain Path: /languages
 */

defined( 'ABSPATH' ) or die();

add_action( 'wp_feed_options', function ( $feed, $url ) {
	$user = parse_url( $feed->feed_url, PHP_URL_USER );
	$pass = parse_url( $feed->feed_url, PHP_URL_PASS );
	if ( ! $user || ! $pass ) {
		return;
	}

	// Remove the user:pass@ part from the feed url.
	$feed->feed_url = str_replace( sprintf( '%s:%s@', $user, $pass ), '', $feed->feed_url );

	// Pass the user and the password to http request args.
	add_filter( 'http_request_args', function ( $args, $url ) use ( $user, $pass ) {
		// Add the Authorization header.
		if ( $user && $pass ) {
			$args['headers']['Authorization'] = 'Basic ' . base64_encode( $user . ':' . $pass );
		}

		return $args;
	}, 10, 2 );

}, 10, 2 );
